Index: branches/HTM-14.1-update-dev0/source/Lib/TLibCommon/TComPattern.cpp
===================================================================
--- branches/HTM-14.1-update-dev0/source/Lib/TLibCommon/TComPattern.cpp	(revision 1199)
+++ branches/HTM-14.1-update-dev0/source/Lib/TLibCommon/TComPattern.cpp	(revision 1200)
@@ -380,229 +349,225 @@
     for (i=0; i<uiWidth; i++)
     {
-      piAdiTemp[i] = iDCValue;
+      piIntraTemp[i] = iDCValue;
     }
     for (i=1; i<uiHeight; i++)
     {
-      piAdiTemp[i*uiWidth] = iDCValue;
+      piIntraTemp[i*uiWidth] = iDCValue;
     }
   }
   else if (iNumIntraNeighbor == iTotalUnits)
   {
-    // Fill top-left border with rec. samples
+    // Fill top-left border and top and top right with rec. samples
     piRoiTemp = piRoiOrigin - iPicStride - 1;
-    piAdiTemp[0] = piRoiTemp[0];
-
-    // Fill left border with rec. samples
+
+    for (i=0; i<uiWidth; i++)
+    {
+#if O0043_BEST_EFFORT_DECODING
+      piIntraTemp[i] = piRoiTemp[i] << bitDepthDelta;
+#else
+      piIntraTemp[i] = piRoiTemp[i];
+#endif
+    }
+
+    // Fill left and below left border with rec. samples
     piRoiTemp = piRoiOrigin - 1;
 
-    if (bLMmode)
-    {
-      piRoiTemp --; // move to the second left column
-    }
-
-    for (i=0; i<uiCuHeight; i++)
-    {
-      piAdiTemp[(1+i)*uiWidth] = piRoiTemp[0];
+    for (i=1; i<uiHeight; i++)
+    {
+#if O0043_BEST_EFFORT_DECODING
+      piIntraTemp[i*uiWidth] = (*(piRoiTemp)) << bitDepthDelta;
+#else
+      piIntraTemp[i*uiWidth] = *(piRoiTemp);
+#endif
       piRoiTemp += iPicStride;
     }
-
-    // Fill below left border with rec. samples
-    for (i=0; i<uiCuHeight; i++)
-    {
-      piAdiTemp[(1+uiCuHeight+i)*uiWidth] = piRoiTemp[0];
-      piRoiTemp += iPicStride;
-    }
-
-    // Fill top border with rec. samples
-    piRoiTemp = piRoiOrigin - iPicStride;
-    for (i=0; i<uiCuWidth; i++)
-    {
-      piAdiTemp[1+i] = piRoiTemp[i];
-    }
-    
-    // Fill top right border with rec. samples
-    piRoiTemp = piRoiOrigin - iPicStride + uiCuWidth;
-    for (i=0; i<uiCuWidth; i++)
-    {
-      piAdiTemp[1+uiCuWidth+i] = piRoiTemp[i];
-    }
   }
   else // reference samples are partially available
   {
-    Int  iNumUnits2 = iNumUnitsInCu<<1;
-    Int  iTotalSamples = iTotalUnits*iUnitSize;
-    Pel  piAdiLine[5 * MAX_CU_SIZE];
-    Pel  *piAdiLineTemp; 
-    Bool *pbNeighborFlags;
-    Int  iNext, iCurr;
-    Pel  piRef = 0;
+    // all above units have "unitWidth" samples each, all left/below-left units have "unitHeight" samples each
+    const Int  iTotalSamples = (iLeftUnits * unitHeight) + ((iAboveUnits + 1) * unitWidth);
+    Pel  piIntraLine[5 * MAX_CU_SIZE];
+    Pel  *piIntraLineTemp;
+    const Bool *pbNeighborFlags;
+
 
     // Initialize
     for (i=0; i<iTotalSamples; i++)
     {
-      piAdiLine[i] = iDCValue;
-    }
-    
+      piIntraLine[i] = iDCValue;
+    }
+
     // Fill top-left sample
     piRoiTemp = piRoiOrigin - iPicStride - 1;
-    piAdiLineTemp = piAdiLine + (iNumUnits2*iUnitSize);
-    pbNeighborFlags = bNeighborFlags + iNumUnits2;
+    piIntraLineTemp = piIntraLine + (iLeftUnits * unitHeight);
+    pbNeighborFlags = bNeighborFlags + iLeftUnits;
     if (*pbNeighborFlags)
     {
-      piAdiLineTemp[0] = piRoiTemp[0];
-      for (i=1; i<iUnitSize; i++)
-      {
-        piAdiLineTemp[i] = piAdiLineTemp[0];
-      }
-    }
-
-    // Fill left & below-left samples
+#if O0043_BEST_EFFORT_DECODING
+      Pel topLeftVal=piRoiTemp[0] << bitDepthDelta;
+#else
+      Pel topLeftVal=piRoiTemp[0];
+#endif
+      for (i=0; i<unitWidth; i++)
+      {
+        piIntraLineTemp[i] = topLeftVal;
+      }
+    }
+
+    // Fill left & below-left samples (downwards)
     piRoiTemp += iPicStride;
-    if (bLMmode)
-    {
-      piRoiTemp --; // move the second left column
-    }
-    piAdiLineTemp--;
+    piIntraLineTemp--;
     pbNeighborFlags--;
-    for (j=0; j<iNumUnits2; j++)
+
+    for (j=0; j<iLeftUnits; j++)
     {
       if (*pbNeighborFlags)
       {
-        for (i=0; i<iUnitSize; i++)
-        {
-          piAdiLineTemp[-i] = piRoiTemp[i*iPicStride];
-        }
-      }
-      piRoiTemp += iUnitSize*iPicStride;
-      piAdiLineTemp -= iUnitSize;
+        for (i=0; i<unitHeight; i++)
+        {
+#if O0043_BEST_EFFORT_DECODING
+          piIntraLineTemp[-i] = piRoiTemp[i*iPicStride] << bitDepthDelta;
+#else
+          piIntraLineTemp[-i] = piRoiTemp[i*iPicStride];
+#endif
+        }
+      }
+      piRoiTemp += unitHeight*iPicStride;
+      piIntraLineTemp -= unitHeight;
       pbNeighborFlags--;
     }
 
-    // Fill above & above-right samples
+    // Fill above & above-right samples (left-to-right) (each unit has "unitWidth" samples)
     piRoiTemp = piRoiOrigin - iPicStride;
-    piAdiLineTemp = piAdiLine + ((iNumUnits2+1)*iUnitSize);
-    pbNeighborFlags = bNeighborFlags + iNumUnits2 + 1;
-    for (j=0; j<iNumUnits2; j++)
+    // offset line buffer by iNumUints2*unitHeight (for left/below-left) + unitWidth (for above-left)
+    piIntraLineTemp = piIntraLine + (iLeftUnits * unitHeight) + unitWidth;
+    pbNeighborFlags = bNeighborFlags + iLeftUnits + 1;
+    for (j=0; j<iAboveUnits; j++)
     {
       if (*pbNeighborFlags)
       {
-        for (i=0; i<iUnitSize; i++)
-        {
-          piAdiLineTemp[i] = piRoiTemp[i];
-        }
-      }
-      piRoiTemp += iUnitSize;
-      piAdiLineTemp += iUnitSize;
+        for (i=0; i<unitWidth; i++)
+        {
+#if O0043_BEST_EFFORT_DECODING
+          piIntraLineTemp[i] = piRoiTemp[i] << bitDepthDelta;
+#else
+          piIntraLineTemp[i] = piRoiTemp[i];
+#endif
+        }
+      }
+      piRoiTemp += unitWidth;
+      piIntraLineTemp += unitWidth;
       pbNeighborFlags++;
     }
 
     // Pad reference samples when necessary
-    iCurr = 0;
-    iNext = 1;
-    piAdiLineTemp = piAdiLine;
-    while (iCurr < iTotalUnits)
-    {
-      if (!bNeighborFlags[iCurr])
-      {
-        if(iCurr == 0)
-        {
-          while (iNext < iTotalUnits && !bNeighborFlags[iNext])
+    Int iCurrJnit = 0;
+    Pel  *piIntraLineCur   = piIntraLine;
+    const UInt piIntraLineTopRowOffset = iLeftUnits * (unitHeight - unitWidth);
+
+    if (!bNeighborFlags[0])
+    {
+      // very bottom unit of bottom-left; at least one unit will be valid.
+      {
+        Int   iNext = 1;
+        while (iNext < iTotalUnits && !bNeighborFlags[iNext])
+        {
+          iNext++;
+        }
+        Pel *piIntraLineNext = piIntraLine + ((iNext < iLeftUnits) ? (iNext * unitHeight) : (piIntraLineTopRowOffset + (iNext * unitWidth)));
+        const Pel refSample = *piIntraLineNext;
+        // Pad unavailable samples with new value
+        Int iNextOrTop = std::min<Int>(iNext, iLeftUnits);
+        // fill left column
+        while (iCurrJnit < iNextOrTop)
+        {
+          for (i=0; i<unitHeight; i++)
           {
-            iNext++;
+            piIntraLineCur[i] = refSample;
           }
-          piRef = piAdiLine[iNext*iUnitSize];
-          // Pad unavailable samples with new value
-          while (iCurr < iNext)
+          piIntraLineCur += unitHeight;
+          iCurrJnit++;
+        }
+        // fill top row
+        while (iCurrJnit < iNext)
+        {
+          for (i=0; i<unitWidth; i++)
           {
-            for (i=0; i<iUnitSize; i++)
-            {
-              piAdiLineTemp[i] = piRef;
-            }
-            piAdiLineTemp += iUnitSize;
-            iCurr++;
+            piIntraLineCur[i] = refSample;
           }
-        }
-        else
-        {
-          piRef = piAdiLine[iCurr*iUnitSize-1];
-          for (i=0; i<iUnitSize; i++)
+          piIntraLineCur += unitWidth;
+          iCurrJnit++;
+        }
+      }
+    }
+
+    // pad all other reference samples.
+    while (iCurrJnit < iTotalUnits)
+    {
+      if (!bNeighborFlags[iCurrJnit]) // samples not available
+      {
+        {
+          const Int numSamplesInCurrUnit = (iCurrJnit >= iLeftUnits) ? unitWidth : unitHeight;
+          const Pel refSample = *(piIntraLineCur-1);
+          for (i=0; i<numSamplesInCurrUnit; i++)
           {
-            piAdiLineTemp[i] = piRef;
+            piIntraLineCur[i] = refSample;
           }
-          piAdiLineTemp += iUnitSize;
-          iCurr++;
-        }
-      }
-      else
-      {
-        piAdiLineTemp += iUnitSize;
-        iCurr++;
+          piIntraLineCur += numSamplesInCurrUnit;
+          iCurrJnit++;
+        }
+      }
+      else
+      {
+        piIntraLineCur += (iCurrJnit >= iLeftUnits) ? unitWidth : unitHeight;
+        iCurrJnit++;
       }
     }
 
     // Copy processed samples
-    piAdiLineTemp = piAdiLine + uiHeight + iUnitSize - 2;
+
+    piIntraLineTemp = piIntraLine + uiHeight + unitWidth - 2;
+    // top left, top and top right samples
     for (i=0; i<uiWidth; i++)
     {
-      piAdiTemp[i] = piAdiLineTemp[i];
-    }
-    piAdiLineTemp = piAdiLine + uiHeight - 1;
+      piIntraTemp[i] = piIntraLineTemp[i];
+    }
+
+    piIntraLineTemp = piIntraLine + uiHeight - 1;
     for (i=1; i<uiHeight; i++)
     {
-      piAdiTemp[i*uiWidth] = piAdiLineTemp[-i];
-    }
-  }
-}
-
-Int* TComPattern::getAdiOrgBuf( Int /*iCuWidth*/, Int /*iCuHeight*/, Int* piAdiBuf)
-{
-  return piAdiBuf;
-}
-
-Int* TComPattern::getAdiCbBuf( Int /*iCuWidth*/, Int /*iCuHeight*/, Int* piAdiBuf)
-{
-  return piAdiBuf;
-}
-
-Int* TComPattern::getAdiCrBuf(Int iCuWidth,Int iCuHeight, Int* piAdiBuf)
-{
-  return piAdiBuf+(iCuWidth*2+1)*(iCuHeight*2+1);
-}
-
-/** Get pointer to reference samples for intra prediction
- * \param uiDirMode   prediction mode index
- * \param log2BlkSize size of block (2 = 4x4, 3 = 8x8, 4 = 16x16, 5 = 32x32, 6 = 64x64)
- * \param piAdiBuf    pointer to unfiltered reference samples
- * \return            pointer to (possibly filtered) reference samples
- *
- * The prediction mode index is used to determine whether a smoothed reference sample buffer is returned.
- */
-Int* TComPattern::getPredictorPtr( UInt uiDirMode, UInt log2BlkSize, Int* piAdiBuf )
-{
-  Int* piSrc;
-  assert(log2BlkSize >= 2 && log2BlkSize < 7);
-  Int diff = min<Int>(abs((Int) uiDirMode - HOR_IDX), abs((Int)uiDirMode - VER_IDX));
-  UChar ucFiltIdx = diff > m_aucIntraFilter[log2BlkSize - 2] ? 1 : 0;
-  if (uiDirMode == DC_IDX)
-  {
-    ucFiltIdx = 0; //no smoothing for DC or LM chroma
-  }
-
-  assert( ucFiltIdx <= 1 );
-
-  Int width  = 1 << log2BlkSize;
-  Int height = 1 << log2BlkSize;
-  
-  piSrc = getAdiOrgBuf( width, height, piAdiBuf );
-
-  if ( ucFiltIdx )
-  {
-    piSrc += (2 * width + 1) * (2 * height + 1);
-  }
-
-  return piSrc;
-}
-
-Bool TComPattern::isAboveLeftAvailable( TComDataCU* pcCU, UInt uiPartIdxLT )
+      piIntraTemp[i*uiWidth] = piIntraLineTemp[-i];
+    }
+  }
+}
+
+Bool TComPrediction::filteringIntraReferenceSamples(const ComponentID compID, UInt uiDirMode, UInt uiTuChWidth, UInt uiTuChHeight, const ChromaFormat chFmt, const Bool intraReferenceSmoothingDisabled)
+{
+  Bool bFilter;
+
+  if (!filterIntraReferenceSamples(toChannelType(compID), chFmt, intraReferenceSmoothingDisabled))
+  {
+    bFilter=false;
+  }
+  else
+  {
+    assert(uiTuChWidth>=4 && uiTuChHeight>=4 && uiTuChWidth<128 && uiTuChHeight<128);
+
+    if (uiDirMode == DC_IDX)
+    {
+      bFilter=false; //no smoothing for DC or LM chroma
+    }
+    else
+    {
+      Int diff = min<Int>(abs((Int) uiDirMode - HOR_IDX), abs((Int)uiDirMode - VER_IDX));
+      UInt sizeIndex=g_aucConvertToBit[uiTuChWidth];
+      assert(sizeIndex < MAX_INTRA_FILTER_DEPTHS);
+      bFilter = diff > m_aucIntraFilter[toChannelType(compID)][sizeIndex];
+    }
+  }
+  return bFilter;
+}
+
+Bool isAboveLeftAvailable( TComDataCU* pcCU, UInt uiPartIdxLT )
 {
   Bool bAboveLeftFlag;
@@ -611,5 +576,5 @@
   if(pcCU->getSlice()->getPPS()->getConstrainedIntraPred())
   {
-    bAboveLeftFlag = ( pcCUAboveLeft && pcCUAboveLeft->getPredictionMode( uiPartAboveLeft ) == MODE_INTRA );
+    bAboveLeftFlag = ( pcCUAboveLeft && pcCUAboveLeft->isIntra( uiPartAboveLeft ) );
   }
   else
@@ -620,5 +585,5 @@
 }
 
-Int TComPattern::isAboveAvailable( TComDataCU* pcCU, UInt uiPartIdxLT, UInt uiPartIdxRT, Bool *bValidFlags )
+Int isAboveAvailable( TComDataCU* pcCU, UInt uiPartIdxLT, UInt uiPartIdxRT, Bool *bValidFlags )
 {
   const UInt uiRasterPartBegin = g_auiZscanToRaster[uiPartIdxLT];
@@ -634,5 +599,5 @@
     if(pcCU->getSlice()->getPPS()->getConstrainedIntraPred())
     {
-      if ( pcCUAbove && pcCUAbove->getPredictionMode( uiPartAbove ) == MODE_INTRA )
+      if ( pcCUAbove && pcCUAbove->isIntra( uiPartAbove ) )
       {
         iNumIntra++;
@@ -661,9 +626,9 @@
 }
 
-Int TComPattern::isLeftAvailable( TComDataCU* pcCU, UInt uiPartIdxLT, UInt uiPartIdxLB, Bool *bValidFlags )
+Int isLeftAvailable( TComDataCU* pcCU, UInt uiPartIdxLT, UInt uiPartIdxLB, Bool *bValidFlags )
 {
   const UInt uiRasterPartBegin = g_auiZscanToRaster[uiPartIdxLT];
   const UInt uiRasterPartEnd = g_auiZscanToRaster[uiPartIdxLB]+1;
-  const UInt uiIdxStep = pcCU->getPic()->getNumPartInWidth();
+  const UInt uiIdxStep = pcCU->getPic()->getNumPartInCtuWidth();
   Bool *pbValidFlags = bValidFlags;
   Int iNumIntra = 0;
@@ -675,5 +640,5 @@
     if(pcCU->getSlice()->getPPS()->getConstrainedIntraPred())
     {
-      if ( pcCULeft && pcCULeft->getPredictionMode( uiPartLeft ) == MODE_INTRA )
+      if ( pcCULeft && pcCULeft->isIntra( uiPartLeft ) )
       {
         iNumIntra++;
@@ -703,5 +668,5 @@
 }
 
-Int TComPattern::isAboveRightAvailable( TComDataCU* pcCU, UInt uiPartIdxLT, UInt uiPartIdxRT, Bool *bValidFlags )
+Int isAboveRightAvailable( TComDataCU* pcCU, UInt uiPartIdxLT, UInt uiPartIdxRT, Bool *bValidFlags )
 {
   const UInt uiNumUnitsInPU = g_auiZscanToRaster[uiPartIdxRT] - g_auiZscanToRaster[uiPartIdxLT] + 1;
@@ -712,8 +677,8 @@
   {
     UInt uiPartAboveRight;
-    TComDataCU* pcCUAboveRight = pcCU->getPUAboveRightAdi( uiPartAboveRight, uiPartIdxRT, uiOffset );
+    TComDataCU* pcCUAboveRight = pcCU->getPUAboveRight( uiPartAboveRight, uiPartIdxRT, uiOffset );
     if(pcCU->getSlice()->getPPS()->getConstrainedIntraPred())
     {
-      if ( pcCUAboveRight && pcCUAboveRight->getPredictionMode( uiPartAboveRight ) == MODE_INTRA )
+      if ( pcCUAboveRight && pcCUAboveRight->isIntra( uiPartAboveRight ) )
       {
         iNumIntra++;
@@ -743,7 +708,7 @@
 }
 
-Int TComPattern::isBelowLeftAvailable( TComDataCU* pcCU, UInt uiPartIdxLT, UInt uiPartIdxLB, Bool *bValidFlags )
-{
-  const UInt uiNumUnitsInPU = (g_auiZscanToRaster[uiPartIdxLB] - g_auiZscanToRaster[uiPartIdxLT]) / pcCU->getPic()->getNumPartInWidth() + 1;
+Int isBelowLeftAvailable( TComDataCU* pcCU, UInt uiPartIdxLT, UInt uiPartIdxLB, Bool *bValidFlags )
+{
+  const UInt uiNumUnitsInPU = (g_auiZscanToRaster[uiPartIdxLB] - g_auiZscanToRaster[uiPartIdxLT]) / pcCU->getPic()->getNumPartInCtuWidth() + 1;
   Bool *pbValidFlags = bValidFlags;
   Int iNumIntra = 0;
@@ -752,8 +717,8 @@
   {
     UInt uiPartBelowLeft;
-    TComDataCU* pcCUBelowLeft = pcCU->getPUBelowLeftAdi( uiPartBelowLeft, uiPartIdxLB, uiOffset );
+    TComDataCU* pcCUBelowLeft = pcCU->getPUBelowLeft( uiPartBelowLeft, uiPartIdxLB, uiOffset );
     if(pcCU->getSlice()->getPPS()->getConstrainedIntraPred())
     {
-      if ( pcCUBelowLeft && pcCUBelowLeft->getPredictionMode( uiPartBelowLeft ) == MODE_INTRA )
+      if ( pcCUBelowLeft && pcCUBelowLeft->isIntra( uiPartBelowLeft ) )
       {
         iNumIntra++;
Index: branches/HTM-14.1-update-dev0/source/Lib/TLibCommon/TComPattern.h
===================================================================
--- branches/HTM-14.1-update-dev0/source/Lib/TLibCommon/TComPattern.h	(revision 1199)
+++ branches/HTM-14.1-update-dev0/source/Lib/TLibCommon/TComPattern.h	(revision 1200)
@@ -2,7 +2,7 @@
  * License, included below. This software may be subject to other third party
  * and contributor rights, including patent rights, and no such rights are
- * granted under this license.  
+ * granted under this license.
  *
-* Copyright (c) 2010-2015, ITU/ISO/IEC
+ * Copyright (c) 2010-2015, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -40,5 +40,4 @@
 
 // Include files
-#include <stdio.h>
 #include "CommonDef.h"
 
@@ -51,4 +50,5 @@
 
 class TComDataCU;
+class TComTU;
 
 /// neighbouring pixel access class for one component
@@ -56,38 +56,20 @@
 {
 private:
-  Int   m_iOffsetLeft;
-  Int   m_iOffsetAbove;
-  Pel*  m_piPatternOrigin;
-  
+  Pel*  m_piROIOrigin;
+
 public:
   Int   m_iROIWidth;
   Int   m_iROIHeight;
   Int   m_iPatternStride;
-  
-  /// return starting position of buffer
-  Pel*  getPatternOrigin()        { return  m_piPatternOrigin; }
-  
+  Int   m_bitDepth;
+
   /// return starting position of ROI (ROI = &pattern[AboveOffset][LeftOffset])
   __inline Pel*  getROIOrigin()
   {
-    return  m_piPatternOrigin + m_iPatternStride * m_iOffsetAbove + m_iOffsetLeft;
+    return  m_piROIOrigin;
   }
-  
+
   /// set parameters from Pel buffer for accessing neighbouring pixels
-  Void setPatternParamPel ( Pel*        piTexture,
-                           Int         iRoiWidth,
-                           Int         iRoiHeight,
-                           Int         iStride,
-                           Int         iOffsetLeft,
-                           Int         iOffsetAbove );
-  
-  /// set parameters of one color component from CU data for accessing neighbouring pixels
-  Void setPatternParamCU  ( TComDataCU* pcCU,
-                           UChar       iComp,
-                           UChar       iRoiWidth,
-                           UChar       iRoiHeight,
-                           Int         iOffsetLeft,
-                           Int         iOffsetAbove,
-                           UInt        uiAbsZorderIdx );
+  Void setPatternParamPel( Pel* piTexture, Int iRoiWidth, Int iRoiHeight, Int iStride, Int bitDepth );
 };
 
@@ -97,6 +79,6 @@
 private:
   TComPatternParam  m_cPatternY;
-  TComPatternParam  m_cPatternCb;
-  TComPatternParam  m_cPatternCr;
+//  TComPatternParam  m_cPatternCb;
+  //TComPatternParam  m_cPatternCr;
 #if H_3D_IC
   Bool              m_bICFlag;
@@ -105,8 +87,8 @@
   Bool              m_bSDCMRSADFlag;
 #endif
-  static const UChar m_aucIntraFilter[5];
-  
+
+
 public:
-  
+
   // ROI & pattern information, (ROI = &pattern[AboveOffset][LeftOffset])
   Pel*  getROIY()                 { return m_cPatternY.getROIOrigin();    }
@@ -114,4 +96,5 @@
   Int   getROIYHeight()           { return m_cPatternY.m_iROIHeight;      }
   Int   getPatternLStride()       { return m_cPatternY.m_iPatternStride;  }
+  Int   getBitDepthY()            { return m_cPatternY.m_bitDepth; }
 
 #if H_3D_IC
@@ -124,64 +107,10 @@
 #endif
 
-  // access functions of ADI buffers
-  Int*  getAdiOrgBuf              ( Int iCuWidth, Int iCuHeight, Int* piAdiBuf );
-  Int*  getAdiCbBuf               ( Int iCuWidth, Int iCuHeight, Int* piAdiBuf );
-  Int*  getAdiCrBuf               ( Int iCuWidth, Int iCuHeight, Int* piAdiBuf );
-  
-  Int*  getPredictorPtr           ( UInt uiDirMode, UInt uiWidthBits, Int* piAdiBuf );
   // -------------------------------------------------------------------------------------------------------------------
   // initialization functions
   // -------------------------------------------------------------------------------------------------------------------
-  
+
   /// set parameters from Pel buffers for accessing neighbouring pixels
-  Void initPattern            ( Pel*        piY,
-                               Pel*        piCb,
-                               Pel*        piCr,
-                               Int         iRoiWidth,
-                               Int         iRoiHeight,
-                               Int         iStride,
-                               Int         iOffsetLeft,
-                               Int         iOffsetAbove );
-  
-  /// set parameters from CU data for accessing neighbouring pixels
-  Void  initPattern           ( TComDataCU* pcCU,
-                               UInt        uiPartDepth,
-                               UInt        uiAbsPartIdx );
-  
-  /// set luma parameters from CU data for accessing ADI data
-  Void  initAdiPattern        ( TComDataCU* pcCU,
-                               UInt        uiZorderIdxInPart,
-                               UInt        uiPartDepth,
-                               Int*        piAdiBuf,
-                               Int         iOrgBufStride,
-                               Int         iOrgBufHeight,
-                               Bool&       bAbove,
-                               Bool&       bLeft
-                              ,Bool        bLMmode = false // using for LM chroma or not
-                               );
-  
-  /// set chroma parameters from CU data for accessing ADI data
-  Void  initAdiPatternChroma  ( TComDataCU* pcCU,
-                               UInt        uiZorderIdxInPart,
-                               UInt        uiPartDepth,
-                               Int*        piAdiBuf,
-                               Int         iOrgBufStride,
-                               Int         iOrgBufHeight,
-                               Bool&       bAbove,
-                               Bool&       bLeft );
-
-private:
-
-  /// padding of unavailable reference samples for intra prediction
-  Void  fillReferenceSamples        (Int bitDepth, Pel* piRoiOrigin, Int* piAdiTemp, Bool* bNeighborFlags, Int iNumIntraNeighbor, Int iUnitSize, Int iNumUnitsInCu, Int iTotalUnits, UInt uiCuWidth, UInt uiCuHeight, UInt uiWidth, UInt uiHeight, Int iPicStride, Bool bLMmode = false);
-  
-
-  /// constrained intra prediction
-  Bool  isAboveLeftAvailable  ( TComDataCU* pcCU, UInt uiPartIdxLT );
-  Int   isAboveAvailable      ( TComDataCU* pcCU, UInt uiPartIdxLT, UInt uiPartIdxRT, Bool* bValidFlags );
-  Int   isLeftAvailable       ( TComDataCU* pcCU, UInt uiPartIdxLT, UInt uiPartIdxLB, Bool* bValidFlags );
-  Int   isAboveRightAvailable ( TComDataCU* pcCU, UInt uiPartIdxLT, UInt uiPartIdxRT, Bool* bValidFlags );
-  Int   isBelowLeftAvailable  ( TComDataCU* pcCU, UInt uiPartIdxLT, UInt uiPartIdxLB, Bool* bValidFlags );
-
+  Void initPattern( Pel* piY, Int iRoiWidth, Int iRoiHeight, Int iStride, Int bitDepthLuma );
 };
 
